// <script>
//////////////////////////////////////////////////////////////////
// Javascript for punjab Mochikit http binding client (punchi)  //
//////////////////////////////////////////////////////////////////

punchi = function() {
    // Punchi object
}

punchi.NAME = 'punchi';

punchi.__repr__ = function() {
    return '[' + this.NAME + ']';
};

 	
punchi.toString = function() {
    return this.__repr__();
};

// Error message class
var ERROR = Object();


//////////////////////////////
// DOM and Name Space Stuff //
//////////////////////////////
var NS_HTTPBIND = "http://jabber.org/protocol/httpbind";
var NS_AUTH     = "jabber:iq:auth";
var NS_ROSTER   = "jabber:iq:roster";
var NS_CLIENT   = 'jabber:client';
var NS_X_DATA   = 'jabber:x:data';
var NS_SASL     = 'urn:ietf:params:xml:ns:xmpp-sasl';
var NS_BIND     = 'urn:ietf:params:xml:ns:xmpp-bind';
var NS_FEATURES = 'stream:features';
var NS_STREAMS  = 'urn:ietf:params:xml:ns:xmpp-streams';

// stanzas
// var ELEMENT  = MochiKit.DOM.createDOMFunc();

var HBODY    = MochiKit.DOM.createDOMFunc('body');
var AUTH     = MochiKit.DOM.createDOMFunc('auth');
var BIND     = MochiKit.DOM.createDOMFunc('bind');


var MESSAGE  = MochiKit.DOM.createDOMFunc('message');
var MBODY    = MochiKit.DOM.createDOMFunc('body');
var SUBJECT  = MochiKit.DOM.createDOMFunc('subject');
var RESOURCE  = MochiKit.DOM.createDOMFunc('resource');
var JID  = MochiKit.DOM.createDOMFunc('jid');

var PRESENCE = MochiKit.DOM.createDOMFunc('presence');
var STATUS   = MochiKit.DOM.createDOMFunc('status');
var SHOW     = MochiKit.DOM.createDOMFunc('show');

var IQ       = MochiKit.DOM.createDOMFunc('iq');

var X        = MochiKit.DOM.createDOMFunc('X');

var LOGIN_FORM = MochiKit.DOM.FORM();

/////////////////
// Utility     //
/////////////////

var punchi_log     = MochiKit.Logging.log;
var punchi_error   = MochiKit.Logging.logError;
var punchi_debug   = MochiKit.Logging.logDebug;
var punchi_warning = MochiKit.Logging.logWarning;


var punchi_toHTML = MochiKit.DOM.toHTML;


// Set up some GLOBALS
var punchi_connected = false;

var punchi_server_features = null;
var punchi_secure = 'false';

// TODO - make this like the rest of MochiKit?
function punchiConnection(resource, timeout, idle_timeout, connection_lost) {
    // resource - http binding url resource to use
    // timeout  - http binding timeout
    // idle_timeout  - http binding timeout
    // connection_lost  - handler when connection is lost
   this.resource = resource;
   
   // request id for body tags
   this.rid = Math.floor(Math.random() * 87654323);
	  
   this.ack = -1;
   this.seq = -1;
 	
   this.paused = 0;
   this.id = 0;
   this.failureCount = 0;

   this.requests = Array();
   this.messages = Array();
   this.outputs = Array();

   if (timeout == undefined) {
       timeout = 30;
   }
   if (idle_timeout == undefined) {
       idle_timeout = 300;
   }
   if (connection_lost == undefined) {
       connection_lost = null;
   }
   
   this.timeout = timeout * 1000;
   this.idle_timeout = idle_timeout * 1000;
   this.connection_lost = connection_lost;

   this.sid = null;
   this.streamId = null;
   this.requestId = 0;
   this.authId = 0;
   this.secure = 'false';
   this.features = null;
   this._anonymous = false;

   // Methods

   this.connect = function (jid, pass, wait, hold, callback, cb_inst) {
       this.jid = jid;
       this.pass = pass;
       if (this.pass==null) {
		this._anonymous = true; 
       }
       
       // parse jid for domain
       this.domain = jid.substring(jid.indexOf("@") + 1);

       // build the body tag
       var bodyelem = HBODY({'rid' : this.rid++,
			     'xmlns': NS_HTTPBIND,
			     'to': this.domain,
			     'wait': wait,
			     'hold': hold,
			     
	   });

       var d = this.request(bodyelem, this.doConnect,this, callback);
	       
   };

   // perform an XMLHttpRequest
   this.request = function (data, func, args)
   {

       req = MochiKit.Async.getXMLHttpRequest();
       req.open("POST", this.resource, true);
       d = MochiKit.Async.sendXMLHttpRequest(req, MochiKit.DOM.toHTML(data));
       if (func) {
	   d.addCallback(func, args);
       }
       // TODO - add an error back
       return d;
   };

   this.send = function(data)
   {
	
          var bodyelem = HBODY({'rid' : this.rid++,
			     'xmlns': NS_HTTPBIND,
			     'sid': this.sid,
	   });
        if (data) {
		MochiKit.DOM.appendChildNodes(bodyelem, data);
	}
	return this.request(bodyelem, null);
   };

   this.authSuccess = function(self, res) {
	var body = res.responseXML.documentElement;	
	var sasl_success = null;
	
	try {
	  sasl_success = body.childNodes[0];
	  
	} catch(e) {
          punchi_error(e);
  	  punchi_error('Error in auth.');
          
        }
	if (sasl_success) {
		// Look for features for bind and session
		var d = self.send();	
		d.addCallback(self.saslSuccess, self);
		d.addErrback(self.authError, self);		
	}

   };


   this.saslSuccess = function(self, res) {
	punchi_debug('saslSuccess');	
	var body = res.responseXML.documentElement;	
	// Grab features
        try {
	 var features = body.childNodes[0].childNodes;
	 	
	} catch(e) {
          punchi_error(e);
  	  punchi_error('No features');
          
        }
	var do_bind = false;
	self.do_session = false;
	punchi_debug(features.length);	
	for (i = 0; i < features.length; i++) {
		if (features[i].nodeName == 'bind') {
			do_bind = true;
		}
		if (features[i].nodeName == 'session') {
			self.do_session = true;
		}		
		punchi_debug(MochiKit.DOM.toHTML(features[i]));
       	}
	// Send bind
	if (do_bind) {
		var iq = IQ({'type':'set','id':self.getId()});
		var bind = BIND({'xmlns': NS_BIND});
		if (self._anonymous) {
			punchi_debug('anonymous');	
		} else {
			MochiKit.DOM.appendChildNodes(bind,JID(self.jid));
		}
		MochiKit.DOM.appendChildNodes(iq, bind);
		var d = self.send(iq);
		d.addCallback(self.bindSuccess, self);
		d.addErrback(self.authError, self);
	}
	
   };

   this.getId = function() {
	var datestamp = new Date();
	return 'punchi' + (datestamp.getTime());
   }	

   this.bindSuccess = function(self, res) {
	punchi_debug('bind Success');
	
	
   };	

   this.authError = function(self, req) {
	punchi_error(self);
	punchi_error(req);
	// Need to alert of an auth error

   };

   this.doConnect = function(self, res, args) {	
	body = res.responseXML.documentElement;	
	// Grab IDs for session, etc.
	self.sid = body.getAttribute('sid');

        self.secure = body.getAttribute('secure');

	// grab mechanisms
        try {
	  self.features = MochiKit.DOM.getElementsByTagAndClassName(body, NS_FEATURES, null);
	} catch(e) {
          punchi_error(e);
  	  punchi_error('No features');
          
        }
	var do_sasl_anon = false;
	var do_sasl_plain = false;
	

	if (self._anonymous) {
		do_sasl_anon = true;
	} else {
		for (i = 0; i < this.features.length; i++) {
			punchi_debug(MochiKit.DOM.toHTML(this.features[i]));

        	}
	}

	// Send login
	if (do_sasl_anon) {
		punchi_debug("Send ANON Login");
		var auth = AUTH({'xmlns': NS_SASL,'mechanism': 'ANONYMOUS'});
		var d = self.send(auth);
		d.addCallback(self.authSuccess, self);
		d.addErrback(self.authError, self);

	}

	if (do_sasl_plain) {
		punchi_debug("Send PLAIN Login");

	}


   }; 

   this.delRequest = function (req)
   {
       var newList = Array();
       for (var i = 0; i < this.requests.length; i++)
	   if (req != this.requests[i])
	       newList.push(this.requests[i]);

       this.requests = newList;
   };
   
}



// </script>

